we can now edit a note and list all notes
[bash-notes.git] / notes.sh
1 #! /bin/bash
2
3 # set -ex
4
5 PID=$$
6 VERSION="0.1"
7
8 set_defaults() {
9 # Binaries to use
10 EDITOR=${EDITOR:-/usr/bin/vim}
11 TERMINAL=${TERMINAL:-/usr/bin/alacritty}
12 JQ=${JQ:-/usr/bin/jq}
13
14 # base directory for program files
15 BASEDIR=${BASEDIR:-~/.local/share/bash-notes}
16 # notes database in json format
17 DB=${BASEDIR}/db.json
18 # directory containing the actual notes
19 NOTESDIR=${BASEDIR}/notes
20
21 } # end set_defaults, do not change this line.
22
23 set_defaults
24
25 # Do not edit below this point
26 RCFILE=${RCFILE:-~/.config/bash-notes.rc}
27 TMPDB=/tmp/db.json
28 BASENAME=$( basename $0 )
29 NOW=$(date +%s)
30
31 if [ ! -x $JQ ]; then
32 echo "jq not found in your PATH"
33 echo "install jq to continue"
34 exit 1
35 fi
36
37 # IMPORT USER DEFINED OPTIONS IF ANY
38 if [[ -f $RCFILE ]]; then
39 source $RCFILE
40 fi
41
42 # We prevent the program from running more than one instance:
43 PIDFILE=/var/tmp/$(basename $0 .sh).pid
44
45 # Make sure the PID file is removed when we kill the process
46 trap 'rm -f $PIDFILE; exit 1' TERM INT
47
48 if [[ -r $PIDFILE ]]; then
49 # PIDFILE exists, so I guess there's already an instance running
50 # let's kill it and run again
51 kill -s 15 $(cat $PIDFILE) > /dev/null 2>&1
52 # should already be deleted by trap, but just to be sure
53 rm $PIDFILE
54 fi
55
56 # create PIDFILE
57 echo $PID > $PIDFILE
58
59 function helptext() {
60 echo "Usage:"
61 echo " $0 [OPTION] ..."
62 echo ""
63 cat << __NOWCONF__
64 ${BASENAME} configuration is:
65
66 base directory: ${BASEDIR}/
67 notes archive: ${NOTESDIR}/
68 notes database: ${DB}
69 rc file: $RCFILE
70 text editor: ${EDITOR}
71 terminal: ${TERMINAL}
72 jq executable: ${JQ}
73 __NOWCONF__
74
75 echo ""
76 echo "The script's parameters are:"
77 echo " -h | --help : This help text"
78 echo " -l | --list : List existing notes"
79 echo " -a | --add <title> : Add new note"
80 echo " -m | --modify <note> : Modify note"
81 echo " -d | -date <note> : Modify date for note"
82 echo " -r | --remove <note> : Remove note"
83 echo " -v | --version : Print version"
84 echo " --userconf : Export User config file"
85 }
86
87 function addnote() {
88 NOTETITLE="$1"
89 echo "adding new note - \"$NOTETITLE\""
90 LASTID=$($JQ '.notes[-1].id | tonumber' $DB)
91 [ null == $LASTID ] && LASTID=0
92 NOTEID=$(( $LASTID + 1 ))
93 touch ${NOTESDIR}/${NOW}
94 $JQ --arg i "$NOTEID" --arg t "$NOTETITLE" --arg f "$NOW" '.notes += [{"id": $i, "title": $t, "file": $f}]' "$DB" > $TMPDB
95 mv $TMPDB $DB
96 $(${TERMINAL} --class notes --title notes -e ${EDITOR} ${NOTESDIR}/${NOW})
97 }
98
99 function listnotes() {
100 echo "listing all notes"
101 echo ""
102 echo "[ID] [TITLE]"
103 for i in ${NOTESDIR}/*; do
104 TITLE=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .title' $DB)
105 ID=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .id' $DB)
106
107 echo "[${ID}] ${TITLE}"
108 done
109 }
110
111 function editnote() {
112 TITLE=$($JQ --arg i $1 '.notes[] | select(.id == $i) | .title' $DB)
113 FILE=$($JQ -r --arg i $1 '.notes[] | select(.id == $i) | .file' $DB)
114 if [ "$TITLE" ]; then
115 echo "editing note $TITLE"
116 $(${TERMINAL} --class notes --title notes -e ${EDITOR} ${NOTESDIR}/${FILE})
117 else
118 echo "note not found"
119 exit 1
120 fi
121 }
122
123 function datenote() {
124 echo "edit date for note \"${1}\""
125 # FILEDATE=$(date -d @$NOW +%d/%m/%Y_%T)
126
127 }
128
129 function rmnote() {
130 NOTE=$1
131 echo "removing note $NOTE"
132 }
133
134 function export_config() {
135 if [ -r ${RCFILE} ]; then
136 echo "Backing up current '${RCFILE}'...."
137 mv -f ${RCFILE} ${RCFILE}.$(date +%Y%m%d_%H%M)
138 fi
139 echo "Writing '${RCFILE}'...."
140 sed -n '/^set_defaults() {/,/^} # end set_defaults, do not change this line./p' $0 \
141 | grep -v set_defaults \
142 | sed -e 's/^\([^=]*\)=\${\1:-\([^}]*\)}/\1=\2/' \
143 > ${RCFILE}
144 if [ -r ${RCFILE} ]; then
145 echo "Taking no further action."
146 exit 0
147 else
148 echo "Could not write '${RCFILE}'...!"
149 exit 1
150 fi
151 }
152
153 # we should expand on this function to add a sample note and explain a little bit
154 # how the program works.
155 function firstrun() {
156 [ -f $RCFILE ] && RC=$RCFILE || RC="none"
157
158 clear
159 echo "${BASENAME} configuration:
160
161 base directory: ${BASEDIR}/
162 notes archive: ${NOTESDIR}/
163 notes database: ${DB}
164 rc file: $RC
165 text editor: ${EDITOR}
166 terminal: ${TERMINAL}
167 jq executable: ${JQ}
168 "
169
170 read -r -p "Do you wish to continue? (y/N) " ANSWER
171 case $ANSWER in
172 y|Y )
173 mkdir -p $NOTESDIR
174 cat << __EOL__ > ${DB}
175 {
176 "params": {
177 "version": "${VERSION}",
178 "dbversion": "${NOW}"
179 },
180 "notes": []
181 }
182 __EOL__
183 echo; echo "All done, you can now write your first note."
184 ;;
185 * )
186 echo "No changes made. Exiting"
187 exit
188 ;;
189 esac
190 }
191
192 # check for notes dir existance and create it in case it doesn't exists
193 if [[ ! -d $NOTESDIR ]]; then
194 # we don't have a directory. FIRST RUN?
195 firstrun
196 fi
197
198 # NOTE: This requires GNU getopt. On Mac OS X and FreeBSD, you have to install this
199 # separately; see below.
200 GOPT=`getopt -o hvla:m:d:r: --long help,version,list,userconf,add:,modify:,date:,remove:,editor:,storage: \
201 -n 'bash-notes' -- "$@"`
202
203 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
204
205 # Note the quotes around `$GOPT': they are essential!
206 eval set -- "$GOPT"
207
208 while true; do
209 case "$1" in
210 -h | --help )
211 helptext
212 exit
213 ;;
214 -v | --version )
215 echo $BASENAME v${VERSION}
216 exit
217 ;;
218 -l | --list )
219 listnotes
220 exit
221 ;;
222 -a | --add )
223 TITLE="$2"
224 shift 2
225 addnote "$TITLE"
226 ;;
227 -m | --modify )
228 NOTE="$2"
229 shift 2
230 editnote "$NOTE"
231 ;;
232 -d | --date )
233 NOTE="$2"
234 shift 2
235 datenote "$NOTE"
236 ;;
237 -r | --remove )
238 NOTE="$2"
239 shift 2
240 rmnote "$NOTE"
241 ;;
242 --userconf )
243 export_config
244 echo "config exported to \"$RCFILE\""
245 exit
246 ;;
247 -- )
248 shift; break
249 ;;
250 * )
251 break
252 ;;
253 esac
254 done
255